Subject: Re: [PATCH v3 2/3] patch-id: document new behaviour

From: "Michael S. Tsirkin" <[email-masked]>
Date: Mon, 31 Mar 2014 23:42:05 +0300

On Mon, Mar 31, 2014 at 12:54:46PM -0700, Junio C Hamano wrote:
> "Michael S. Tsirkin" <[email-masked]> writes:
> 
> > The hash used is mostly an internal implementation detail, isn't it?
> 
> Yes, but that does not mean we can break people who keep an external
> database indexed with the patch-id by changing the default under
> them, and "they can give --unstable option to work it around" is a
> workaround, not a fix.  Without this change, they did not have to do
> anything.
> 
> I would imagine that most of these people will be using the plain
> vanilla "git show" output without any ordering or hunk splitting
> when coming up with such a key.  A possible way forward to allow the
> configuration that corresponds to "-O<orderfile>" while not breaking
> the existing users could be to make the "patch-id --stable" kick in
> automatically (of course, do this only when the user did not give
> the "--unstable" command line option to override) when we see the
> orderfile configuration in the repository, or when we see that the
> incoming patch looks like reordered (e.g. has multiple "diff --git"
> header lines that refer to the same path,

This would require us to track affected files in memory.
Issue?

> or the set of files
> mentioned by the "diff --git" lines are not in ascending order),
> perhaps?

I hope a patch-id configuration flag plus maybe checking the orderfile if not
specified together should be good enough.

-- 
MST